///////////////////////////////////////////////////////////////////////////////
// NABLA - a Numerical Analysis Based LAnguage                               //
//                                                                           //
// Copyright (C) 2014~2017 CEA/DAM/DIF                                       //
// IDDN.FR.001.520002.000.S.P.2014.000.10500                                 //
//                                                                           //
// Contributor(s): CAMIER Jean-Sylvain - Jean-Sylvain.Camier@cea.fr          //
//                                                                           //
// This software is a computer program whose purpose is to translate         //
// numerical-analysis specific sources and to generate optimized code        //
// for different targets and architectures.                                  //
//                                                                           //
// This software is governed by the CeCILL license under French law and      //
// abiding by the rules of distribution of free software. You can  use,      //
// modify and/or redistribute the software under the terms of the CeCILL     //
// license as circulated by CEA, CNRS and INRIA at the following URL:        //
// "http://www.cecill.info".                                                 //
//                                                                           //
// The CeCILL is a free software license, explicitly compatible with         //
// the GNU GPL.                                                              //
//                                                                           //
// As a counterpart to the access to the source code and rights to copy,     //
// modify and redistribute granted by the license, users are provided only   //
// with a limited warranty and the software's author, the holder of the      //
// economic rights, and the successive licensors have only limited liability.//
//                                                                           //
// In this respect, the user's attention is drawn to the risks associated    //
// with loading, using, modifying and/or developing or reproducing the       //
// software by the user in light of its specific status of free software,    //
// that may mean that it is complicated to manipulate, and that also         //
// therefore means that it is reserved for developers and experienced        //
// professionals having in-depth computer knowledge. Users are therefore     //
// encouraged to load and test the software's suitability as regards their   //
// requirements in conditions enabling the security of their systems and/or  //
// data to be ensured and, more generally, to use and operate it in the      //
// same conditions as regards security.                                      //
//                                                                           //
// The fact that you are presently reading this means that you have had      //
// knowledge of the CeCILL license and that you accept its terms.            //
//                                                                           //
// See the LICENSE file for details.                                         //
///////////////////////////////////////////////////////////////////////////////
#ifndef _NABLA_LEGION_HOOK_H_
#define _NABLA_LEGION_HOOK_H_

// Calls
char* legionHookCallPrefix(nablaMain*,const char*);
void legionHookCallAddExtraParameters(nablaMain*, nablaJob*, int*);
char* legionHookCallITask(nablaMain*,nablaJob*);
char* legionHookCallOTask(nablaMain*,nablaJob*);

// Header
void legionHookHeaderOpen(nablaMain*);
void legionHookHeaderIncludes(nablaMain*);
void legionHookHeaderPostfix(nablaMain*);

// Source
void legionHookSourceOpen(nablaMain*);
void legionHookSourceInclude(nablaMain*);

// MAIN
NABLA_STATUS legionHookMainPrefix(nablaMain*);
NABLA_STATUS legionHookMainPreInit(nablaMain*);
NABLA_STATUS legionHookMainHLT(nablaMain*);
NABLA_STATUS legionHookMainPostfix(nablaMain*);

// TOKENS
char* legionHookTokenPrefix(nablaMain*);
void legionHookTokenSwitch(node*, nablaJob*);
nablaVariable *legionHookTokenVariable(node*,nablaMain*,nablaJob*);
void legionHookTokenOption(nablaMain*,nablaOption*);
void legionHookTokenExit(nablaMain*, nablaJob*);
void legionHookTokenTime(nablaMain*);

// Variables
void legionHookVarsPrefix(nablaMain*);
void legionHookVarsFree(nablaMain*);

// Grammar
bool legionHookGramDump(nablaMain*);
char* legionHookGramEoe(nablaMain*); 
bool legionHookGramDfsExtra(nablaMain*,nablaJob*,bool);

// Forall
char* legionHookForallPrefix(nablaJob*);
char* legionHookForallDump(nablaJob*);
char* legionHookForallPostfix(nablaJob*);

hooks* legion(nablaMain*);

#endif // _NABLA_LEGION_HOOK_H_
 
